#ifndef MOUSEHPP
#define MOUSEHPP

#include <dos.h>
#include <stdlib.h>

#include "graphics.hpp"

#define MOUSE_INTERRUPT 0x33

// mouse buttons definitions
#define MOUSE_LEFT_BUTTON	1
#define MOUSE_RIGHT_BUTTON	2

enum DisplayMode {
  MOUSE_OFF = -1,
  MOUSE_ON = 0
};

// define the mouse driver command code in terms
// of the Microsoft Mouse function number
enum MouseFunctionCode {
	MOUSE_RESET = 0,
	MOUSE_SHOW,
	MOUSE_HIDE,
	MOUSE_STATUS,
	MOUSE_SET_POSITION,
	MOUSE_PRESSED_INFO,
	MOUSE_RELEASED_INFO,
	MOUSE_X_RANGE,
	MOUSE_Y_RANGE
};

class Mouse {

	REGS results;
	DisplayMode display_status;
	int RightHandedCartesian(int);
	void ButtonInfo(MouseFunctionCode, int, int*,
			int*, int*, int*);
	int MouseCommand(MouseFunctionCode,
			  unsigned int bx = 0,
			  unsigned int cx = 0,
			  unsigned int dx = 0);
public:

	Mouse();
	void Show();
	void Hide();
	int Status(int*, int*);
	void SetPosition(int, int);
	void ButtonPressedInfo(int, int*, int*,
			       int*, int*);
	void ButtonReleasedInfo(int, int*, int*,
			       int*, int*);
	void SetXRange(int, int);
	void SetYRange(int, int);

	int LeftButtonDown();
	int RightButtonDown();
	int BothButtonsDown();

	~Mouse() {}
};

#endif
